/*
 * CodeProblem.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class CodeProblem extends JFrame 
{
	
  static JTextField wordTextField = new JTextField();
  static JButton encodeButton = new JButton();
  static JButton decodeButton = new JButton();

  public static void main(String args[]) 
  {
  	//construct frame
    new CodeProblem().show();
  }

  public CodeProblem() 
  {
  	// code to build the form
    setTitle("Code Problem");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    wordTextField.setText("");
    wordTextField.setColumns(20);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(wordTextField, gridConstraints);
    encodeButton.setText("Encode");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(encodeButton, gridConstraints);
    encodeButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		encodeButtonActionPerformed(e);
    	}
    });
    decodeButton.setText("Decode");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(decodeButton, gridConstraints);
    decodeButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		decodeButtonActionPerformed(e);
    	}
    });
    pack();
	}
	
	private void encodeButtonActionPerformed(ActionEvent e)
	{
    // Read typed word - initialize encoded word
    String word1 = wordTextField.getText();
    String word2 = "";
    // Find Unicode representation for each character and subtract 1
    for (int i = 0; i < word1.length(); i++)
    {
      word2 += (char) ((int) word1.charAt(i) - 1);
    }
    // Display encoded word
    wordTextField.setText(word2);
	}

	private void decodeButtonActionPerformed(ActionEvent e)
	{
		// Read typed word - initialize decoded word
    String word1 = wordTextField.getText();
    String word2 = "";
    // Find Unicode representation for each character and add 1
    for (int i = 0; i < word1.length(); i++)
    {
      word2 += (char) ((int) word1.charAt(i) + 1);
    }
    // Display decoded word
    wordTextField.setText(word2);
	}

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }

}
