/*
 * StudentProfile.java
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class StudentProfile extends JFrame 
{
  
  static JLabel nameLabel = new JLabel();
  static JTextField nameTextField = new JTextField();
  static JPanel sexPanel = new JPanel();
  static ButtonGroup sexButtonGroup = new ButtonGroup();
  static JRadioButton maleRadioButton = new JRadioButton();
  static JRadioButton femaleRadioButton = new JRadioButton();
  static JPanel gradePanel = new JPanel();
  static ButtonGroup gradeButtonGroup = new ButtonGroup();
  static JRadioButton firstRadioButton = new JRadioButton();
  static JRadioButton secondRadioButton = new JRadioButton();
  static JRadioButton thirdRadioButton = new JRadioButton();
  static JRadioButton fourthRadioButton = new JRadioButton();
  static JRadioButton fifthRadioButton = new JRadioButton();
  static JRadioButton sixthRadioButton = new JRadioButton();
  static JRadioButton[] gradeRadioButton = new JRadioButton[6];
  static JPanel birthPanel = new JPanel();
  static JSpinner monthSpinner = new JSpinner();
  static JSpinner daySpinner = new JSpinner();
  static JSpinner yearSpinner = new JSpinner();
  static JPanel picturePanel = new JPanel();
  static JLabel pictureLabel = new JLabel();
  static JButton showButton = new JButton();
  static JButton newButton = new JButton();
  static JButton exitButton = new JButton();
  static JButton loadButton = new JButton();
  static JFileChooser pictureChooser = new JFileChooser();
  
  static String[] monthNames = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
  static int[] days = new int[12];
  static String grade;

  public static void main(String args[]) 
  {
  	// construct frame
    new StudentProfile().show();
    // days in each month
    days[0] = 31;
    days[1] = 28;
    days[2] = 31;
    days[3] = 30;
    days[4] = 31;
    days[5] = 30;
    days[6] = 31;
    days[7] = 31;
    days[8] = 30;
    days[9] = 31;
    days[10] = 30;
    days[11] = 31;
    grade = "first";
  }
  
  public StudentProfile() 
  {
  	// create frame
  	setTitle("Student Profile");
  	setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
   	getContentPane().setLayout(new GridBagLayout());
   	
   	// position controls
   	GridBagConstraints gridConstraints;
		nameLabel.setText("Name");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.insets = new Insets(10, 0, 0, 0);
		getContentPane().add(nameLabel, gridConstraints);
		nameTextField.setText("");
    nameTextField.setColumns(20);
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
		gridConstraints.insets = new Insets(10, 0, 0, 0);
    getContentPane().add(nameTextField, gridConstraints);
		
    sexPanel.setLayout(new GridBagLayout());
		sexPanel.setBorder(BorderFactory.createTitledBorder("Sex"));
    maleRadioButton.setText("Male");
    maleRadioButton.setSelected(true);
		sexButtonGroup.add(maleRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.anchor = GridBagConstraints.WEST;
		sexPanel.add(maleRadioButton, gridConstraints);
    femaleRadioButton.setText("Female");
		sexButtonGroup.add(femaleRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		gridConstraints.anchor = GridBagConstraints.WEST;
		sexPanel.add(femaleRadioButton, gridConstraints);
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(0, 10, 0, 0);
    getContentPane().add(sexPanel, gridConstraints);

    gradeRadioButton[0] = firstRadioButton;
    gradeRadioButton[1] = secondRadioButton;
    gradeRadioButton[2] = thirdRadioButton;
    gradeRadioButton[3] = fourthRadioButton;
    gradeRadioButton[4] = fifthRadioButton;
    gradeRadioButton[5] = sixthRadioButton;
    gradePanel.setLayout(new GridBagLayout());
		gradePanel.setBorder(BorderFactory.createTitledBorder("Grade"));
    firstRadioButton.setText("First");
    firstRadioButton.setSelected(true);
    secondRadioButton.setText("Second");
    thirdRadioButton.setText("Third");
    fourthRadioButton.setText("Fourth");
    fifthRadioButton.setText("Fifth");
    sixthRadioButton.setText("Sixth");
    for (int i = 0; i < 6; i++)
    {
    	gradeButtonGroup.add(gradeRadioButton[i]);
			gridConstraints = new GridBagConstraints();
			gridConstraints.gridx = 0;
			gridConstraints.gridy = i;
			gridConstraints.anchor = GridBagConstraints.WEST;
			gradePanel.add(gradeRadioButton[i], gridConstraints);
			gradeRadioButton[i].addActionListener(new ActionListener()
			{
  			public void actionPerformed(ActionEvent e) 
  			{
    			gradeRadioButtonActionPerformed(e);
  			}
			});
		}
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.gridheight = 3;
    gridConstraints.insets = new Insets(0, 10, 10, 0);
    getContentPane().add(gradePanel, gridConstraints);

    
    birthPanel.setLayout(new GridBagLayout());
		birthPanel.setBorder(BorderFactory.createTitledBorder("Date of Birth"));
    monthSpinner.setModel(new SpinnerListModel(monthNames));
    monthSpinner.setPreferredSize(new Dimension (100, 25));
    ((JSpinner.DefaultEditor) monthSpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    birthPanel.add(monthSpinner, gridConstraints);
    daySpinner.setModel(new SpinnerNumberModel(1, 1, 31, 1));
    daySpinner.setPreferredSize(new Dimension (100, 25));
    ((JSpinner.DefaultEditor) daySpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    birthPanel.add(daySpinner, gridConstraints);
    yearSpinner.setModel(new SpinnerNumberModel(1990, 1980, 2010, 1));
    yearSpinner.setPreferredSize(new Dimension (100, 25));
    // change format so commas don't appear in year
    JSpinner.NumberEditor myEditor = new JSpinner.NumberEditor(yearSpinner, "0");
    yearSpinner.setEditor(myEditor);
    ((JSpinner.DefaultEditor) yearSpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    birthPanel.add(yearSpinner, gridConstraints);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(birthPanel, gridConstraints);

    
    showButton.setText("Show Student Profile");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    getContentPane().add(showButton, gridConstraints);
    showButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		showButtonActionPerformed(e);
    	}
    });
    newButton.setText("New Student Profile");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 3;
		gridConstraints.anchor = GridBagConstraints.NORTH;
    getContentPane().add(newButton, gridConstraints);
    newButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		newButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });

    picturePanel.setLayout(new GridBagLayout());
		picturePanel.setBorder(BorderFactory.createTitledBorder("Picture"));
    pictureLabel.setPreferredSize(new Dimension(100, 150));
		pictureLabel.setOpaque(true);
		pictureLabel.setBackground(Color.WHITE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
	  picturePanel.add(pictureLabel, gridConstraints);
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(0, 0, 0, 10);
    getContentPane().add(picturePanel, gridConstraints);

    loadButton.setText("Load Picture");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(0, 0, 0, 10);
    getContentPane().add(loadButton, gridConstraints);
    loadButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		loadButtonActionPerformed(e);
    	}
    });

    pack();
  	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
 
  }
	

	private void gradeRadioButtonActionPerformed(ActionEvent e)
  {
  	grade = e.getActionCommand().toLowerCase();
  }

	private void loadButtonActionPerformed(ActionEvent e)
  {
   	String[] ext = new String[] {"jpg"};
  	pictureChooser.addChoosableFileFilter(new ExampleFileFilter(ext, "Student Photos"));
  	if (pictureChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
  	{ 
  	  pictureLabel.setIcon(new ImageIcon(pictureChooser.getSelectedFile().toString()));
  	}
	}
	private void showButtonActionPerformed(ActionEvent e)
  {
    int isLeap;
    String msg, pronoun;
    int age;
    int m, d, y;
    int mnow, dnow, ynow;
    // Check for leap year and if February is current month
    // need to convert year to string, then int
    y = Integer.valueOf(yearSpinner.getValue().toString()).intValue();
    if (monthSpinner.getValue() == "February" && y % 4 == 0 && y % 100 != 0)
    {
      isLeap = 1;
    }
    else
    {
      isLeap = 0;
    }
    // find index for selected month
    for (m = 0; m < 12; m++)
    {
    	if (monthSpinner.getValue() == monthNames[m])
    	{
    		break;
    	}
    }
   	// Check to make sure current day doesn't exceed number of days in month
    d = Integer.valueOf(daySpinner.getValue().toString()).intValue();
    if (d > days[m] + isLeap)
    {
    	JOptionPane.showConfirmDialog(null, "Only " + (days[m] + isLeap) + " days in " + monthSpinner.getValue() + ".", "Invalid Birth Date", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
      return;
    }
    
   	// Use current date to compute age 
    Calendar today = Calendar.getInstance();
    mnow = today.get(Calendar.MONTH);
    dnow = today.get(Calendar.DAY_OF_MONTH);
    ynow = today.get(Calendar.YEAR);
    age = ynow - y;
    if (m > mnow || m == mnow && d > dnow)
    {
      age--;
    }
    // Check for valid age
    if (age < 0)
    {
    	JOptionPane.showConfirmDialog(null, "Birth date is before current date.", "Invalid Birth Date", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
      return;
    }
    // Check to make sure name entered
    if (nameTextField.getText().equals(""))
    {
    	JOptionPane.showConfirmDialog(null, "The profile requires a name.", "No Name Entered", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
      nameTextField.requestFocus();
      return;
    }
    // Put together student profile message
    msg = nameTextField.getText() + " is a student in the " + grade + " grade.\n";
    if (maleRadioButton.isSelected())
    {
      pronoun = "He ";
    }
    else
    {
      pronoun = "She ";
    }
    msg += pronoun + " is " + age + " years old.\n";
   	JOptionPane.showConfirmDialog(null, msg, "Student Profile", JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE);
  }
	private void newButtonActionPerformed(ActionEvent e)
  {
    // Blank out name and picture
    nameTextField.setText("");
    pictureLabel.setIcon(null);
  }
	
	private void exitButtonActionPerformed(ActionEvent e)
  {
  	  	System.exit(0);
  }

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }
}
